module Firehol
  module Helpers
    def ports_to_s(ports)
      case ports
      when String
        ports
      when Hash
        ports.map do |protocol, port_array|
          port_array.map { |port| "#{protocol}/#{port}" }
        end.flatten.join(" ")
      when Array
        ports.join(" ")
      end
    end

    def format_type(type, protocol)
      case protocol
      when "ipv4" then "#{type}4"
      when "ipv6" then "#{type}6"
      else type
      end
    end
  end
end
