class Chef
  class Provider::Firewall < Chef::Provider::LWRPBase
    include Firehol::Helpers

    provides :firewall

    use_inline_resources

    def whyrun_supported?
      true
    end

    action :create do
      package "firehol"

      service "firehol" do
        action %i(enable)
      end

      cookbook_file "/etc/default/firehol" do
        cookbook "firehol"
        group    "root"
        mode     "0600"
        owner    "root"
        notifies :restart, "service[firehol]"
      end
    end

    action :restart do
      service "firehol" do
        action %i(nothing)
      end

      template "/etc/firehol/firehol.conf" do
        cookbook  "firehol"
        group     "root"
        mode      "0600"
        owner     "root"
        variables options:  new_resource.options, version:  new_resource.version
        action    :create
        notifies  :restart, "service[firehol]"
      end
    end
  end
end
