class Chef
  class Provider::FirewallRule < Chef::Provider::LWRPBase
    provides :firewall_rule

    def whyrun_supported?
      true
    end

    attributes = %i(command service type)
    action :create do
      rule = {
        command: new_resource.command,
        service: new_resource.service,
        type:    new_resource.type
      }

      name         = new_resource.name
      interface    = new_resource.interface
      current_rule = node["firewall"]["interfaces"][interface]["rules"][name]
      if !current_rule || current_rule.symbolize_keys.slice(*attributes) != rule
        converge_by("Update/create #{name} for #{interface}") do
          rule.keys.each do |key|
            node.normal["firewall"]["interfaces"][interface]["rules"][name][key] = rule[key]
          end

          firewall_resource = run_context.resource_collection.find(firewall: "firehol")
          raise "could not find a firewall resource" unless firewall_resource
          new_resource.notifies(:restart, firewall_resource, :delayed)
        end
      end
    end
  end
end
